Subject: Re: bug#77998: 30.0.50; thai-pattachote input method is missing characters?

From: Eli Zaretskii <[email-masked]>
Date: Wed, 23 Apr 2025 15:11:29 +0300

> Date: Tue, 22 Apr 2025 16:51:09 -0600
> From:  Robert Nikander via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> I've been learning how to read Thai. I tried the input method `thai-pattachote`. I'm a beginner so not 100% sure about this, but it seems to be missing the character ฉ (THAI CHARACTER CHO CHING). Is that a bug? An input method should have all the characters in the alphabet, no?
> 
> When you do `describe-input-method` it shows you a keyboard, like this:
> 
> +----------------------------------------------------------------+
>  | = + | ๒ " | ๓ / | ๔ , | ๕ ? | ู ุ | ๗ _ | ๘ . | ๙ ( | ๐ ) | ๑ - | ๖ % | ฃ ฅ |
> +----------------------------------------------------------------+
>    | ็ ๊ | ต ฤ | ย ๆ | อ ญ | ร ษ | ่ ึ | ด ฝ | ม ซ | ว ถ | แ ฒ | ใ ฯ | ฒ ฦ |
>   +------------------------------------------------------------+
>     | ้ ๋ | ท ธ | ง ำ | ก ณ | ั ์ | ี ื | า ผ | น ช | เ โ | ไ ฆ | ข ฑ | ฺ ํ |
>    +-----------------------------------------------------------+
>       | บ ฎ | ป ฎ | ล ฐ | ห ภ | ิ ั | ค ศ | ส ฮ | ะ ฟ | จ ฒ | พ ฬ |
>      +-------------------------------------------------+
> 
> The character is not there. There may be more missing characters. This is just the first one I hit as I’m working through the alphabet. 

Thanks.  Can you try identifying additional missing characters, if
there are any?  An input method might omit some characters, but not if
they are used frequently enough.  So I think we would like to add any
missing characters, if that is possible.

I didn't look closely enough at this input method, but one problem
could be that there are no vacant keys left to add more characters.
If that is the case, and if the missing characters are relatively
rare, I think the only way forward is to add a new input method, which
uses key sequences of length greater than 1 to produce Thai
characters.

(I don't read Thai, so apologies if the above makes little or no
sense.)